#include <SoftwareSerial.h>

String ssid = "";
String pswrd = "";
String webpage;

bool ledStatus = false;

#define readyLed 2

SoftwareSerial esp(11, 12);

void setup() {
  // put your setup code here, to run once:
  webpage.reserve(250);
  esp.begin(19200);
  Serial.begin(19200);
  pinMode(readyLed, OUTPUT);
  delay(1000);
  connectWiFi();
  digitalWrite(readyLed, HIGH);
  ledStatus = true;
}

void loop() {
  // put your main code here, to run repeatedly:
  if (esp.available()) {
    char httpRequest[250];
    memset(httpRequest, '\0', sizeof(httpRequest));
    unsigned int requestCounter = 0;
    delay(5);
    while (esp.available()) {
      if (requestCounter < sizeof(httpRequest)) {
        httpRequest[requestCounter] = esp.read();
        requestCounter++;
      }
      else {
        esp.read();
      }
      delay(1);
    }
    Serial.println(httpRequest);
    if (strstr(httpRequest, "+IPD,") != NULL) {
      char* ptr = strstr(httpRequest, "+IPD,");
      int connectionIdIndex = ptr - httpRequest;
      int connectionId = httpRequest[connectionIdIndex + 5] - 48;
      webpage = "<!DOCTYPE HTML><html><head><title>Pretzelboard</title></head><body><form method=\"GET\"><button type=\"submit\" name=\"led\">led</button></form></html>";
      sendWebpage(connectionId);
      sendData("AT+CIPCLOSE=" + String(connectionId) + "\r\n", 1000);
      if (strstr(httpRequest, "led") != NULL) {
        ledStatus ^=1;
        digitalWrite(readyLed, ledStatus);
      }
    }
  }
}

void connectWiFi(void)
{
  //connect with network
  sendData("AT+RST\r\n", 2000);  //reset module
  sendData("AT+CWMODE=3\r\n", 1000); //configure as acces point and client
  sendData("AT+CWJAP=\"" + ssid + "\",\"" + pswrd + "\"\r\n", 15000);
  sendData("AT+CIFSR\r\n", 1000);  //get ip address
  sendData("AT+CIPMUX=1\r\n", 1000); //configure for multiple connections
  sendData("AT+CIPSERVER=1,80\r\n", 1000); //turn on server on port 80
}

void sendData(String command, const int timeout)
{
  //send data to esp module
  String response;
  response.reserve(150);
  esp.print(command);
  unsigned long time = millis();
  while ((time + timeout) > millis())
  {
    while (esp.available())
    {
      response += (char)esp.read();
    }
  }
  Serial.println(response);
}

void sendWebpage(int id)
{
  //send webpage to receiver
  String cipSend = "AT+CIPSEND=" + String(id) + "," + String(webpage.length()) + "\r\n";
  sendData(cipSend, 1000);
  delay(10);
  sendData(webpage, 2000);
}

